import 'package:flutter_zsdk/src/models/bluetooth_printer.dart';
import 'package:plugin_platform_interface/plugin_platform_interface.dart';

import 'flutter_zsdk_method_channel.dart';

abstract class FlutterZsdkPlatform extends PlatformInterface {
  /// Constructs a FlutterZsdkPlatform.
  FlutterZsdkPlatform() : super(token: _token);

  static final Object _token = Object();

  static FlutterZsdkPlatform _instance = MethodChannelFlutterZsdk();

  /// The default instance of [FlutterZsdkPlatform] to use.
  ///
  /// Defaults to [MethodChannelFlutterZsdk].
  static FlutterZsdkPlatform get instance => _instance;

  /// Platform-specific implementations should set this with their own
  /// platform-specific class that extends [FlutterZsdkPlatform] when
  /// they register themselves.
  static set instance(FlutterZsdkPlatform instance) {
    PlatformInterface.verifyToken(instance, _token);
    _instance = instance;
  }

  Future<String?> getPlatformVersion() {
    throw UnimplementedError('platformVersion() has not been implemented.');
  }

  Future<Stream<dynamic>> findBluetoothPrinters() {
    throw UnimplementedError('findBluetoothPrinters() has not been implemented.');
  }
}
